#!/bin/bash -e
# 
# Goal: idempotent script to setup this server with an archive
# built from the test fixture.  That is, a reduced set of manpages
# to just test the functionality of the tool.
# 
# Notes:
# 
# - This script should be run as root
# - This script should be created/structured so that
#   it's idempotent

DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"

# Defining arch avoids shellcheck lint
ARCH=""

source "$DIR/../config"
mkdir -p "$DEBDIR"

# do this to avoid having to rm -rf whatever was in the mirror before I
# start.  This seems the safest to avoid mistakingly blowing away
# someones mirror if they run this script accidently.  It would instead
# just blow away the packages.gz files, which are fast to re-download.
cd -- "$DIR/fixtures/mirror" && find . -type f -exec sh -c '
	for x do
		mkdir -p "$0/${x%/*}"
		mv "$x" "$0/$x"
	done
' "$DEBDIR" {} +
