#!/bin/bash -e
# 
#TODO: CLEANUP
# Goal: idempotent script to setup this server with an archive
# built from the test fixture.  That is, a reduced set of manpages
# to just test the functionality of the tool.
# 
# Notes:
# 
# - This script should be run as root
# - This script should be created/structured so that
#   it's idempotent

DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
MIRROR="$DIR/fixtures/mirror"
PORTS="http://ports.ubuntu.com"

# Keeps shellcheck happy
ARCH=""
source "$DIR/../config"

# - multi-arch (s390-tools) - TODO: this makes a lot of manpages, maybe
#   slim down?
# - something in main (acct)
PACKAGES="powerpc-ibm-utils acct s390-tools"

# Download packages for all combinations.  Note, some packages are not
# in all pockets, so don't fail on download errors.
for distro in $DISTROS; do
	for repo in $REPOS; do
		for arch in $ARCH; do

			path="dists/$distro/$repo/binary-$arch"
			packagesgz="$path/Packages.gz"
			mkdir -p "$MIRROR/$path"
			if [ "$arch" == "amd64" ]; then
				site="$ARCHIVE"
			else
				site="$PORTS"
			fi
			echo "$site/$packagesgz"
			curl -s "$site/$packagesgz" -o "$MIRROR/$packagesgz"

			for package in $PACKAGES; do
				filename=$(gunzip -c "$MIRROR/$packagesgz" \
					| egrep "(^Filename: |^Package: )" \
					| sed 'N;s/\n/ /' \
					| grep "Package: $package " \
					| awk '{ print $4 }')
				if [ -n "$filename" ]; then
					echo " - [$package]: $site/$filename"
					curl -fs "$site/$filename" \
						-o "$MIRROR/$path/$filename" \
						--create-dirs
				fi
			done
			(cd "$MIRROR/$path"; dpkg-scanpackages . | gzip -cn > Packages.gz)
			(cd -- "$MIRROR/$path" &&
				find . -type f -name '*.deb' -exec sh -c '
					for x do
						mkdir -p "$0/${x%/*}"
						mv "$x" "$0/$x"
					done
					' "$MIRROR" {} +)
			rm -rf "$MIRROR/$path/pool"
		done
	done
done
